
import java.awt.*;

public class LifeCanvas extends Canvas
{
    private clsLifeController Controller;
    private int SizeFactor;
    
    public void initFeld(int Width, int Height, int Faktor)
    {   
        Controller = new clsLifeController(Width, Height);
        SizeFactor = Faktor;
    }
        
    public void paint(Graphics g)
    {
        int i;
        int j;
        
        for (i=0; i<Controller.getWidth(); i++)
        {
            for (j=0; j<Controller.getHeight(); j++)
            {
                if (Controller.getCellStatus(i, j))
                {
                    g.fillRect(i * SizeFactor, j * SizeFactor, SizeFactor, SizeFactor);
                }
                else
                {
                    g.drawRect(i * SizeFactor, j * SizeFactor, SizeFactor, SizeFactor);
                }
            }
        }
    }
    
    public void setCellStatus(int x, int y, boolean status)
    {
        Controller.setCellStatus(x, y, status);
    }
    
    public boolean getCellStatus(int x, int y)
    {
        return Controller.getCellStatus(x,y);
    }

	public void commitChanges()
	{
		Controller.commitChanges();
	}

	public int getWidth()
	{
		return Controller.getWidth();
	}

	public int getHeight()
	{
		return Controller.getHeight();
	}

	public int move()
	{
		return Controller.move();
	}
}

