
import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class MyGameOfLife extends Applet implements ActionListener
{
  private Panel panSouthPanel;
  private Button btnRun;
//  private Button btnStop;
  private Button btnNewGame;
  private Button btnGoToGen;
  private TextField txtGeneration;
  private LifeCanvas MyCanvas;
  private int Generation;
  
  public void init()
  {
    setBackground(Color.lightGray);
    setLayout(new BorderLayout());

    MyCanvas = new LifeCanvas();
    MyCanvas.initFeld(70,70,9);
    MyCanvas.setBackground(Color.WHITE);
    add(MyCanvas, BorderLayout.CENTER);
      
    panSouthPanel = new Panel();
    									           
    btnNewGame = new Button("Randomize");
	btnNewGame.addActionListener(this);
    panSouthPanel.add(btnNewGame);

	btnRun = new Button("Next Generation");
	btnRun.addActionListener(this);
    panSouthPanel.add(btnRun);
    
    txtGeneration = new TextField("0");
    panSouthPanel.add(txtGeneration);

	btnGoToGen = new Button("Generations forward");
	btnGoToGen.addActionListener(this);
	panSouthPanel.add(btnGoToGen);
	
    add(panSouthPanel, BorderLayout.SOUTH);
    
    MyCanvas.repaint();
  }

  public void actionPerformed(ActionEvent evt)
  {
  	  String Command = evt.getActionCommand();
       
        if (Command.equals("Next Generation"))
        {
            //GameRuns = true;
			MyCanvas.move();
			MyCanvas.repaint();
			
        }
        else if (Command.equals("Randomize"))
        {
            randomize();
            MyCanvas.repaint();
        }
		else if (Command.equals("Generations forward"))
		{
			int i;

			for (i=1; i<(Integer.valueOf(txtGeneration.getText()).intValue()); i++)
			{
				MyCanvas.move();
			}
			MyCanvas.repaint();
		}
  }
    
    
    private void randomize()
    {
        double Rand;
			
        for(int i = 0; i < MyCanvas.getWidth(); i++)
        {
            for(int j = 0; j < MyCanvas.getHeight(); j++)
            {
                Rand = (Math.random() * 2);
                if (Rand>1.85)
                {
                    MyCanvas.setCellStatus(i, j, true);
                }
                else
                {
                    MyCanvas.setCellStatus(i,j, false);
                } 
            }
			
        }
		MyCanvas.commitChanges();
		MyCanvas.repaint();
    }
}
    

    